clear all
clc


 %Importing and purging baseline data
    datapath={'D:\2 reserch论文\RCEP\3 data and counterfactual\files\data_file'}; %complete as necessary
    global BETA THETA DELTA MU PHI ALPHAs SIGMA%defined here
    BETA=readmatrix([datapath{1} '\beta_RCEP.xlsx'],'Range','B2:J62');
    DELTA=readmatrix([datapath{1} '\delta_RCEP.xlsx'],'Range','C2:K3722');
    THETA=readmatrix([datapath{1} '\theta_phi_mu1.xlsx'],'Range','C2:C62');
    PHI=readmatrix([datapath{1} '\theta_phi_mu1.xlsx'],'Range','D2:D62');
    MU=readmatrix([datapath{1} '\theta_phi_mu1.xlsx'],'Range','E2:E62');
    SIGMA=1+THETA;
    TRADE=readmatrix([datapath{1} '\trade_RCEP.xlsx'],'Range','C2:K550'); 
    for n=1:9
    for j=1:549
        if TRADE(j,n)==0
            TRADE(j,n)=1E-09;
        end
    end
    end
    TARIFF=readmatrix([datapath{1} '\tariff_RCEP.xlsx'],'Range','C2:K550');
    save('RAWDATA_RCEP','BETA','DELTA','THETA','PHI','MU','SIGMA','TRADE','TARIFF') %this is the raw data
    save('DATA_RCEP','BETA','DELTA','THETA','PHI','MU','SIGMA','TRADE','TARIFF')
    mycalculations_RCEP
    SIGMA_N_S_S=permute(repmat(SIGMA_N_S,[1 1 S]),[1 3 2]);
    TEMP=sum((1-BETA_N_S_S).*DELTA_N_S_S.*(SIGMA_N_S_S-1)./SIGMA_N_S_S.*permute(repmat(Y_ns,[1 1 S]),[1 3 2]),3);
    ALPHAs=(reshape(sum(EXPENDITURE_N_N_S,1),[N S])-TEMP)./repmat(I,[1 S]);
for j=1:S
    for n=1:N
        if ALPHAs(n,j)<0
            ALPHAs(n,j)=1E-07;
        end
    end
end
    ALPHAs=ALPHAs./repmat(sum(ALPHAs,2),[1 S]);
    save('DATA_RCEP','BETA','DELTA','THETA','PHI','MU','ALPHAs','SIGMA','TRADE','TARIFF')
    [ WELFAREHAT WAGEHAT TRADECs  EXPENDITUREHAT LABORHAT PRICEHAT]=mycounterfactuals(TARIFFs,zeros(N,N,S),zeros(N,1),ones(N,S));
    TRADE=reshape(permute(TRADECs,[1 3 2]),[N*S,N,1]);
    save('DATA_RCEP','BETA','DELTA','THETA','PHI','MU','ALPHAs','SIGMA','TRADE','TARIFF') %remove Deficit
     
    mycalculations_RCEP %re-equilibrium
     Dmax=1 ; 
      while (Dmax >1E-03) 
    [ WELFAREHAT WAGEHAT TRADECs  EXPENDITUREHAT LABORHAT PRICEHAT]=mycounterfactuals(TARIFFs,zeros(N,N,S),zeros(N,1),ones(N,S));
    TRADE=reshape(permute(TRADECs,[1 3 2]),[N*S,N,1]);
    save('DATA_RCEP','BETA','DELTA','THETA','PHI','MU','ALPHAs','SIGMA','TRADE','TARIFF') 
     mycalculations_RCEP
    Dmax=max(D);
      end
      
    tariff_RCEP=readmatrix([datapath{1} '\RCEP_timeline.xlsx'],'Range','D2:W4942');
    temp=reshape(tariff_RCEP,[N,N,S,20 ]);
    tariff_RCEP=permute(temp,[2 1 3 4]);    
   
%% RCEP welfare effects
results=zeros(9,6);
TARIFFCs=tariff_RCEP(:,:,:,20);
ETARIFFCs=zeros(N,N,S);
[ WELFAREHAT WAGEHAT TRADECs  EXPENDITUREHAT LABORHAT PRICEHAT AGGREGATEPRICEINDEXHAT PMjHAT]=mycounterfactuals(TARIFFCs,ETARIFFCs,D,ones(N,S));
[TOT profit Leffect R TOT_sector profit_sector Leffect_sector R_sector]=welfaredecomposition(TRADECs,TARIFFCs,ETARIFFCs,LABORHAT,PRICEHAT,AGGREGATEPRICEINDEXHAT,PMjHAT,WAGEHAT, EXPENDITUREHAT);
for i=1:9
realwage=WAGEHAT(i)./AGGREGATEPRICEINDEXHAT(i);
temp=100*(TOT(i))+100*(profit(i))+100*(Leffect(i))+100*(R(i));
results(i,:)=[temp,100*(TOT(i)),100*(profit(i)),100*(R(i)),100*(Leffect(i)),100*((realwage-1))];
end
Table2=[results(3,:);results(5,:);results(6,:);results(1,:);results(2,:);results(7,:);results(4,:);results(9,:);results(8,:)];
welfare_sector=TOT_sector+ profit_sector +Leffect_sector +R_sector;
[w_sector T_sector P_sector r_sector L_sector ]=sector(TRADEs, welfare_sector, TOT_sector,  profit_sector,  Leffect_sector, R_sector);


cd(['Results\'])
ASEAN_sector=[(w_sector(1,:))'*1000,(T_sector(1,:))'*1000,(P_sector(1,:))'*1000,(r_sector(1,:))'*100,(L_sector(1,:))'*1000];
xlswrite('ASEAN_sector',ASEAN_sector) 
AUS_sector=[(w_sector(2,:))'*1000,(T_sector(2,:))'*1000,(P_sector(2,:))'*1000,(r_sector(2,:))'*1000,(L_sector(2,:))'*1000];
xlswrite('AUS_sector',AUS_sector) 
CHN_sector=[(w_sector(3,:))'*1000,(T_sector(3,:))'*1000,(P_sector(3,:))'*1000,(r_sector(3,:))'*1000,(L_sector(3,:))'*1000];
xlswrite('CHN_sector',CHN_sector) 
EU_sector=[(w_sector(4,:))'*1000,(T_sector(4,:))'*1000,(P_sector(4,:))'*1000,(r_sector(4,:))'*1000,(L_sector(4,:))'*1000];
xlswrite('EU_sector',EU_sector) 
JPN_sector=[(w_sector(5,:))'*1000,(T_sector(5,:))'*1000,(P_sector(5,:))'*1000,(r_sector(5,:))'*1000,(L_sector(5,:))'*1000];
xlswrite('JPN_sector',JPN_sector) 
KOR_sector=[(w_sector(6,:))'*1000,(T_sector(6,:))'*1000,(P_sector(6,:))'*1000,(r_sector(6,:))'*1000,(L_sector(6,:))'*1000];
xlswrite('KOR_sector',KOR_sector) 
NZL_sector=[(w_sector(7,:))'*1000,(T_sector(7,:))'*1000,(P_sector(7,:))'*1000,(r_sector(7,:))'*1000,(L_sector(7,:))'*1000];
xlswrite('NZL_sector',NZL_sector) 
ROW_sector=[(w_sector(8,:))'*1000,(T_sector(8,:))'*1000,(P_sector(8,:))'*1000,(r_sector(8,:))'*1000,(L_sector(8,:))'*1000];
xlswrite('ROW_sector',ROW_sector) 
USA_sector=[(w_sector(9,:))'*1000,(T_sector(9,:))'*1000,(P_sector(9,:))'*1000,(r_sector(9,:))'*1000,(L_sector(9,:))'*1000];
xlswrite('USA_sector',USA_sector) 




%% RCEP trade effects
t1=TRADEs;
t2=TRADECs;
for i=1:9
    t1(i,i,:)=0;
    t2(i,i,:)=0;
end
RCEP_cty=[1 2 3 5 6 7 ];
bilateral_tradehat=sum(t2,3)./sum(t1,3);
temp=sum(t1,3);
exp_to_RCEP1=sum(temp(:,RCEP_cty),2);
imp_from_RCEP1=(sum(temp(RCEP_cty,:),1))';
temp=sum(t2,3);
exp_to_RCEP2=sum(temp(:,RCEP_cty),2);
imp_from_RCEP2=(sum(temp(RCEP_cty,:),1))';

exp_to_RCEPhat=exp_to_RCEP2./exp_to_RCEP1;
imp_from_RCEPhat=imp_from_RCEP2./imp_from_RCEP1;

trade_RCEP=(exp_to_RCEP2+imp_from_RCEP2)./(exp_to_RCEP1+imp_from_RCEP1);
RCEP_RCEP=sum(exp_to_RCEP2(RCEP_cty,:),1)./sum(exp_to_RCEP1(RCEP_cty,:),1);

trade_2019=readmatrix([datapath{1} '\trade_RCEP.xlsx'],'Range','C2:K550');
TEMP=reshape(trade_2019',[N N S]);
trade_2019=sum(permute(TEMP,[2 1 3]),3);
for i=1:9
    trade_2019(i,i,:)=0;
end
bilateral_value=trade_2019.*(bilateral_tradehat-1)/100;
exp_to_RCEP_value=sum(trade_2019(:,RCEP_cty),2).*(exp_to_RCEPhat-1)/100;
imp_from_RCEP_value=(sum(trade_2019(RCEP_cty,:),1))'.*(imp_from_RCEPhat-1)/100;
temp=sum(trade_2019(:,RCEP_cty),2);
RCEP_RCEP_value=sum(temp(RCEP_cty,:),1)*(RCEP_RCEP-1)/100;












