
function [wf0 lf0 pf0 xf0 LambdaHAT] = equilibrium_C(TARIFFCs,ETARIFFCs,DC,maxit,tol,vfactor)
global ALPHAs  BETA THETA DELTA SIGMA_N_S MU PHI TRADEs D Y_ns DELTA_N_S_S BETA_N_S_S BETA_N_S I LABORINCOME_share EXPENDITURE_N_N_S MEANTARIFF WEIGHTs EXPENDITURE_1_N_S TAUTRADEs TARIFFREVENUE Ds Lambda_N_N_S TARIFFs N S   SIGMA_1_1_S SIGMA_N_1_S SIGMA_N_N_S PHIs_1_1_S PHIs_N_1_S PHIs_N_N_S  MUs_1_1_S MUs_N_1_S MUs_N_N_S BETAs_1_N_S BETAs_N_N_S EXPENDITURE  LABORINCOME_N_S LABORINCOME %Defined here
% initialize vectors of ex-post wage and price factors 
 wf0=  ones(N,1);  lf0 =ones(N,S);  pf0=ones(N,S); xf0=ones(N,S);
 test=[];
 fmax = 1; e = 1;
while (e <= maxit) && (fmax > tol)
    
%Miscellaneous calculations
TAUHATs=(1+TARIFFCs)./(1+TARIFFs);
EHATS=(1+ETARIFFCs)./1;

%Computing PMjHAT
TEMP=repmat(pf0,[1 1 S]);
MU_N_S_S=repmat(MUs_1_1_S,[N S 1]);
TEMP2=reshape(sum(DELTA_N_S_S.*(TEMP.^(1-MU_N_S_S)),2),[N S]);
PMjHAT=TEMP2.^(1./(1-reshape(MUs_N_1_S,[N S])));

%Computing CHAT
TEMP=1./(lf0.^(reshape(PHIs_N_1_S,[N S])));
CHAT=TEMP.*(repmat(wf0,[1 S]).^BETA_N_S).*(PMjHAT.^(1-BETA_N_S));

%Computing LambdaHAT
TEMP=(permute(repmat(CHAT,[1 1 N]),[1 3 2]).*TAUHATs.*EHATS).^(1-SIGMA_N_N_S);
LambdaHAT=TEMP./((permute(repmat(pf0,[1 1 N]),[3 1 2])).^(1-SIGMA_N_N_S));

%Computing EQUILIBRIUMCONDITION1: PRICEHAT
TEMP=Lambda_N_N_S.*((permute(repmat(CHAT,[1 1 N]),[1 3 2]).*TAUHATs.*EHATS).^(1-SIGMA_N_N_S));
PRICEHAT=reshape(sum(TEMP,1),[N S]).^(1./(1-SIGMA_N_S));


%Computing EQUILIBRIUMCONDITION2: LABORHAT
TEMP=LABORINCOME_N_S.*repmat(wf0,[1 S]);
TEMP2=BETA_N_S.*((SIGMA_N_S-1)./SIGMA_N_S).*reshape(sum(EXPENDITURE_N_N_S.*LambdaHAT.*permute(repmat(xf0,[1 1 N]),[3 1 2])./((1+TARIFFCs).*(1+ETARIFFCs)),2),[N S]);
LABORHAT=TEMP2./TEMP;

%Computing EQUILIBRIUMCONDITION3: WAGEHAT
WAGEHAT=sum(TEMP2,2)./LABORINCOME;

%Computing EQUILIBRIUMCONDITION4: EXPENDITUREHAT
TEMP=EXPENDITURE_N_N_S.*LambdaHAT.*permute(repmat(xf0,[1 1 N]),[3 1 2])./((1+TARIFFCs).*(1+ETARIFFCs));
TEMP1=ALPHAs.*repmat((LABORINCOME.*wf0+(sum(sum(TARIFFCs.*(1+ETARIFFCs).*TEMP,1),3))'+(sum(sum(ETARIFFCs.*TEMP,2),3))+DC+sum( 1./SIGMA_N_S.*reshape(sum(TEMP,2),[N S]),2)),[1 S]);
TEMP2=DELTA_N_S_S.*((repmat(pf0,[1 1 S])).^(1-MU_N_S_S));
SIGMA_N_S_S=permute(repmat(SIGMA_N_S,[1 1 S]),[1 3 2]);
TEMP3=sum((1-BETA_N_S_S).*TEMP2./(repmat(sum(TEMP2,2),[1 S 1])).*(SIGMA_N_S_S-1)./SIGMA_N_S_S.*(permute(repmat(reshape(sum(TEMP,2),[N S]),[1 1 S]),[1 3 2])),3);
EXPENDITUREHAT=(TEMP1+TEMP3)./reshape(sum(EXPENDITURE_N_N_S,1),[N S]);

%iteration wage
wf1 =wf0.*(1-vfactor)+vfactor.*WAGEHAT;
bond=sum(LABORINCOME)/(sum(wf1.*LABORINCOME));
wfmax=sum(abs(wf1-wf0));
wf0=wf1.*bond;

%iteration labor
lf1 =lf0.*(1-vfactor)+vfactor.*LABORHAT;
lfmax=max(max(abs(LABORHAT-lf0)));
lf0=lf1;

%iteration price
pf1 =pf0.*(1-vfactor)+vfactor.*PRICEHAT;
pfmax=max(max(abs(PRICEHAT-pf0)));
pf0=pf1.*bond;

%iteration expenditure
xf1 =xf0.*(1-vfactor)+vfactor.*EXPENDITUREHAT;
xfmax=max(max(abs(EXPENDITUREHAT-xf0)));
xf0=xf1.*bond;

fmax=max([wfmax lfmax pfmax xfmax]);


test=[test fmax] ;
e=e+1;

end

