%--------------------------------------------------
%This function compiles important model conditions
%-------------------------------------------------
function [EQUILIBRIUMCONDITION NUMERAIRECONDITION  AGGREGATEPRICEINDEXHAT TRADECs IHAT PMjHAT]=myconditions(wf0,lf0,pf0,xf0,TARIFFCs,ETARIFFCs,DC);
%Defining global variables
global ALPHAs  BETA THETA DELTA SIGMA_N_S MU PHI TRADEs D Y_ns DELTA_N_S_S BETA_N_S_S BETA_N_S I LABORINCOME_share EXPENDITURE_N_N_S MEANTARIFF WEIGHTs EXPENDITURE_1_N_S TAUTRADEs TARIFFREVENUE Ds Lambda_N_N_S TARIFFs N S   SIGMA_1_1_S SIGMA_N_1_S SIGMA_N_N_S PHIs_1_1_S PHIs_N_1_S PHIs_N_N_S  MUs_1_1_S MUs_N_1_S MUs_N_N_S BETAs_1_N_S BETAs_N_N_S EXPENDITURE  LABORINCOME_N_S LABORINCOME %Defined here

TAUHATs=(1+TARIFFCs)./(1+TARIFFs);
EHATS=(1+ETARIFFCs);

%Computing PMjHAT
TEMP=repmat(pf0,[1 1 S]);
MU_N_S_S=repmat(MUs_1_1_S,[N S 1]);
TEMP2=reshape(sum(DELTA_N_S_S.*(TEMP.^(1-MU_N_S_S)),2),[N S]);
PMjHAT=TEMP2.^(1./(1-reshape(MUs_N_1_S,[N S])));

%Computing CHAT
TEMP=1./(lf0.^(reshape(PHIs_N_1_S,[N S])));
CHAT=TEMP.*(repmat(wf0,[1 S]).^BETA_N_S).*(PMjHAT.^(1-BETA_N_S));

%Computing LambdaHAT
TEMP=(permute(repmat(CHAT,[1 1 N]),[1 3 2]).*TAUHATs.*EHATS).^(1-SIGMA_N_N_S);
LambdaHAT=TEMP./((permute(repmat(pf0,[1 1 N]),[3 1 2])).^(1-SIGMA_N_N_S));

%Computing EQUILIBRIUMCONDITION1: PRICEHAT
TEMP=Lambda_N_N_S.*((permute(repmat(CHAT,[1 1 N]),[1 3 2]).*TAUHATs.*EHATS).^(1-SIGMA_N_N_S));
TEMP1=reshape(sum(TEMP,1),[N S]).^(1./(1-SIGMA_N_S));
EQUILIBRIUMCONDITION1=pf0-TEMP1;

%Computing EQUILIBRIUMCONDITION2: LABORHAT
TEMP=LABORINCOME_N_S.*repmat(wf0,[1 S]);
TEMP2=BETA_N_S.*((SIGMA_N_S-1)./SIGMA_N_S).*reshape(sum(EXPENDITURE_N_N_S.*LambdaHAT.*permute(repmat(xf0,[1 1 N]),[3 1 2])./((1+TARIFFCs).*(1+ETARIFFCs)),2),[N S]);
EQUILIBRIUMCONDITION2=lf0.*TEMP-TEMP2;


%Computing EQUILIBRIUMCONDITION3: WAGEHAT
EQUILIBRIUMCONDITION3=sum(lf0.*LABORINCOME_share,2)-1;


%Computing EQUILIBRIUMCONDITION4: EXPENDITUREHAT
TEMP=EXPENDITURE_N_N_S.*LambdaHAT.*permute(repmat(xf0,[1 1 N]),[3 1 2])./((1+TARIFFCs).*(1+ETARIFFCs));
TEMP1=ALPHAs.*repmat((LABORINCOME.*wf0+(sum(sum(TARIFFCs.*(1+ETARIFFCs).*TEMP,1),3))'+(sum(sum(ETARIFFCs.*TEMP,2),3))+DC+sum( 1./SIGMA_N_S.*reshape(sum(TEMP,2),[N S]),2)),[1 S]);
TEMP2=DELTA_N_S_S.*((repmat(pf0,[1 1 S])).^(1-MU_N_S_S));
SIGMA_N_S_S=permute(repmat(SIGMA_N_S,[1 1 S]),[1 3 2]);
TEMP3=sum((1-BETA_N_S_S).*TEMP2./(repmat(sum(TEMP2,2),[1 S 1])).*(SIGMA_N_S_S-1)./SIGMA_N_S_S.*(permute(repmat(reshape(sum(TEMP,2),[N S]),[1 1 S]),[1 3 2])),3);
EQUILIBRIUMCONDITION4=xf0.*reshape(sum(EXPENDITURE_N_N_S,1),[N S])-(TEMP1+TEMP3);

%Computing EQUILIBRIUMCONDITION
EQUILIBRIUMCONDITION11=reshape(EQUILIBRIUMCONDITION1,[N*S 1]);
EQUILIBRIUMCONDITION21=reshape(EQUILIBRIUMCONDITION2,[N*S 1]);
EQUILIBRIUMCONDITION41=reshape(EQUILIBRIUMCONDITION4,[N*S 1]);
EQUILIBRIUMCONDITION=[EQUILIBRIUMCONDITION11;EQUILIBRIUMCONDITION21;EQUILIBRIUMCONDITION3;EQUILIBRIUMCONDITION41];
%Calculating AGGREGATEPRICEINDEXHAT
AGGREGATEPRICEINDEXHAT=prod(pf0.^(reshape(ALPHAs,[N S])),2);
%Calculating NUMERAIRECONDITION
NUMERAIRECONDITION=sum((LABORINCOME./repmat(sum(LABORINCOME),N,1)).*wf0)-1;
%Calculating TRADECs
TRADECs=EXPENDITURE_N_N_S.*LambdaHAT.*permute(repmat(xf0,[1 1 N]),[3 1 2])./((1+TARIFFCs).*(1+ETARIFFCs));
%Computing IHAT
IHAT=(LABORINCOME.*wf0+(sum(sum(TARIFFCs.*(1+ETARIFFCs).*TRADECs,1),3))'+(sum(sum(ETARIFFCs.*TRADECs,2),3))+DC+sum( 1./SIGMA_N_S.*reshape(sum(TRADECs,2),[N S]),2))./I;

end

%This is checked and correct